///////						   	///////
///////	SLOT-TYPE EQUIP SYSTEM	///////
/////// 						///////
///////	Made by: GhostAnime		///////
/////// 						///////
///////	Dated created:26/06/2007///////
/////// 						///////

//	All right, let us set up a variable to keep track of what item is equipped where:

//	NOTE: Please note that each slot must be typed correctly as this demo does not check
//	 any mistakes of the slot names. If you want it to check, design your own to make it do so.
//	For this system to work, objects must be under /Equip. Please see the demo folder.
mob/var/list/equipslot = null	//	This is initially null'd so we do not use up our
										//	list limit of 65535 needlessly

Equip	//	This datum, Equip, is where all equipping items will be under. Think it as an /obj

	parent_type = /obj	//	We are now making /Equip as a child of /obj, meaning /Equip will
								//	now inherit /obj's properties

	var
		slot					//	The slot in which the item will go in to.
		mob/owner = null

	verb/Equip_item()		//	All items under /Equip will have this verb.
		set
			name = "Equip"
			category = "Weapons"
			src in usr
		Equip()				//	Calls Equip().

	proc/Equip()			//	Time to setup an equipping procedure! You'll soon see that this both
								//	equips and unequips, for convience.
		var
			a
			list/unequipped = null
			Equip/E
		if(!ismob(owner)) return 				//	If the item is not in a /mob, it will not continue the rest.

		// The following is the unequip section of the procedure.

		for(a in owner.equipslot)		 				//	Looping through the owner.equipslot to see if the item is equipped
			if(owner.equipslot[a]==src)				//	If it is equipped (if the object is stored in the list)
				owner.equipslot -= a						// Removes the category from the listing.
				if(!(src in unequipped))		// If this object has not been removed already by this loop
					owner << "\red [name] has been unequipped."
					if(!unequipped) unequipped = list()	//	If the list is false value'd, it initializes a list value so we don't get any errors.
					unequipped += src				//	Adds the item to the unequipped list
					UQuiped()						//	Calls the UQuiped() procedure for anything special (eg: removing of the overlay, by default)

				if(!length(owner.equipslot)) owner.equipslot = null	//	If the slot has no items, the list
																		//	is null'd to save us the limits.

		if(src in unequipped) return	//	If the item was unequipped, the proc stops here. The
												//	reason for this is if 'src' is being equipped and was
												//	already equipped, it means you just want to unequip it.

		//	Now time for the equipping section of the procedure.
		if(slot in owner.equipslot)		 	//	Checking if the slot we need is already in owner.equipslot, meaning an item already exists there. Note that this is not a loop, it is assumed that you are not using a combo-type slot such as "both arm" along with "left arm" and/or "right arm". here, it is a ssumed to be just one slot, "arm".
			E = owner.equipslot[slot]			//	Setting the current equipped item to the slot so we can unequip.
			E.Equip()						//	Unequips the current equipped item so we can equip this one.

		if(!(slot in owner.equipslot))		//	If the slot is not in the equipped list
			if(!owner.equipslot) owner.equipslot = list()	//	If the owner.equipslot is null'd (for list limit preservative), it is now initiated so we do not get any runtime errors.
			owner.equipslot += slot				//	The item's slot has now been added
		owner.equipslot[slot] = src			//	We are setting this item in the current slot for future reference to remove it.
		Quiped()								//	The Quiped() procedure is called, which by default, adds an overlay.
		owner << "\green [name] has been equipped!"


	proc				// The following procedure are called when an item is equipped or unequipped.  Normally I would make it so it is in one proc but people sooner or later would forgot that it's a dual-proc.
						//	If you do customize one of the following procedures, don't forget to call the parent procedure ..() so that the overlays, by default, can be added or removed.
		Quiped()		// Called when an item is equipped.
			owner.overlays += icon(icon,icon_state)	//	By default, this procedure adds an overlay of the current icon/icon_state.
			suffix = "Equipped"	//	Also by default, the suffix is "Equipped"
			return 1
		UQuiped()	//	Called when an item it unequipped.
			//	By default, this procedure removes an overlay of the current icon/icon_state...

			owner.overlays -= icon(icon,icon_state)
			suffix = null	//	Also by default, suffix is null'd
			return 1
